﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using Infragistics.Persistence;

namespace PersistenceXamTileManager
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        private MemoryStream memoryStream = new MemoryStream();
        private PersistenceGroup persistenceGroup = new PersistenceGroup();
        private bool IsSaveCompleted = false;

        public MainWindow()
        {
            InitializeComponent();
            persistenceGroup = this.Resources["igPG"] as PersistenceGroup;
            persistenceGroup.Events.PersistenceSaved += new EventHandler<PersistenceSavedEventArgs>(_PersistenceSaved);
        }

        private void BtnSaveState_Click(object sender, RoutedEventArgs e)
        {
            memoryStream = PersistenceManager.Save(persistenceGroup);
        }

        private void BtnLoadState_Click(object sender, RoutedEventArgs e)
        {
            memoryStream.Position = 0;

            if (IsSaveCompleted)
            {

                // Loads persistence group from MemoryStream
                PersistenceManager.Load(persistenceGroup, memoryStream);
            }
              
        }

        private void _PersistenceSaved(object sender, PersistenceSavedEventArgs e)
        {
            // Flag for Save process completion
            this.IsSaveCompleted = true;
        }
    }
}
